// Blink.asm - sweeps a pattern of three illuminated LED's up and down the 
//              21161 ezkit's six LED's.

#include <def21161.h>
#define JINX  0x1FF000	// wait between each LED
#define PAUSE 0x2fffFFF 	// wait between consecutive sweeps


.section/pm code_sec;

start:
	ustat1=dm(IOFLAG);
	bit set ustat1 FLG4O|FLG5O|FLG6O|FLG7O|FLG8O|FLG9O; 	
	dm(IOFLAG)=ustat1;
	
	r1=0;
	r2=-3;

wayback:
	// count up
	lcntr = 10; do up until lce;
		r0 = DM(IOFLAG);
		r0 = btgl r0 by r1; 			/* toggle 'leading' LED of group */
		r0 = btgl r0 by r2; 			/* toggle 'trailing' LED of group */
		DM(IOFLAG) = r0;
		lcntr=JINX; do delay until lce; /*wait*/
			delay:	nop;
		r1 = r1 + 1; 					/* increment which flag is toggled*/
up:		r2 = r2 + 1;
	
	// count down
	lcntr = 10; do down until lce;
		r1 = r1 - 1; 					/* decrement which flag is toggled*/
		r2 = r2 - 1;
		r0 = DM(IOFLAG);
		r0 = btgl r0 by r1; 			/* toggle 'trailing' LED of group */
		r0 = btgl r0 by r2; 			/* toggle 'leading' LED of group */
		DM(IOFLAG) = r0;
		lcntr=JINX; do delay2 until lce;/*wait*/
			delay2:nop;
down:	nop;

	lcntr = PAUSE; do pause until lce;  /* wait before initiating next sweep */
pause: nop;

	jump wayback;



// Interrupt vector table - mapped to beginning of block0 (mem_ivt)
.section /pm   ivt_sec;
Reserved_1:     rti; 
				nop; 
				nop; 
				nop;
Chip_Reset:     idle; 
				jump start; 
				nop; 
				nop;
